"use strict"	// temporary - for a better debugging

//
// REFACTORING MUST BE COMPLETED WITH INNER CLASSES
//


// this function encapsulates the GUI
class DN4_menu {
	constructor(tool) {
	    // all the "closure" variables
		this.DN4 = tool;			// the variable to access all the other components of the gui

		// handles zoom, pan and shift buttons
		this.currentZoomPanShift = "none";

	
	

		// This inner-class definition must be definitely completed. In particular, states must probly become
		// extensions of this base inner class

		// States of the GUI
		// base class
		class MenuItem {
			constructor(mnId, tool, label, icon, iconStyle, menuBlock, right, enabled, toolTip) {
				this.Id = mnId;
				this.DN4 = tool;
				this.tt = toolTip;
				this.menuBlk = menuBlock;
				// Check if the menu item is enabled
				this.enabled = enabled;
				
				if(typeof $("#"+menuBlock).html() === 'undefined') {
//console.log(mnId+": Must create a new menu <div> for " + menuBlock);
					$("#menus").append("<div id =\"" + menuBlock +
									 "\" style=\"display:none\"><ul></ul><div>");
				} else {
//console.log(mnId+": Menu div " + menuBlock + " already exists");
				}
				$("#"+menuBlock+" ul").append("<li"+(right ? " class=\"r-al\"" : "")+
											  "><a href=\"#\" class=\""+
											  (enabled ? "en" : "dis")+"abled\" id=\""+mnId+
											  "\" title=\"" + toolTip +
											  "\"><i "+iconStyle+"class=\"material-icons\">&#x"+icon+
											  ";</i><span class=\"small\">"+label+
											  "</span></a></li>");
			}
			// Called when the menu is clicked
			click(event) {
				alert("Function not implemented yet");
			}
			mouseover(event) {
				this.DN4.draw.toolTipText = this.tt;
				this.DN4.draw.drawView();
//				console.log("Mouseover on: " + this.Id);
			}
			mouseout(event) {
				this.DN4.draw.toolTipText = "";
				this.DN4.draw.drawView();
//				console.log("Mouseout  on: " + this.Id);
			}
			// Called to check if a menu item gets disabled
			update() {
			}
		}
		
		// menu specification (from class extension)
	//		-- MI_CONNSEP --
		class ConnSepMenuItem extends MenuItem {
			constructor(mnId, tool) {
				super(mnId, tool, "SEP", "E0B6", "", "mn_main", false, true, "Keeps connections during copy, or separate elements - NOT IMPLEMENTED YET");
				this.sep = true;
			}
			click(event) {
				if(this.sep) {
					$("#"+this.Id).html('<i class="material-icons">&#xE0B3;</i><span class="small">CONN</span>');
					this.sep = false;
				} else {
					$("#"+this.Id).html('<i class="material-icons">&#xE0B6;</i><span class="small">SEP</span>');
					this.sep = true;
				}
			}
		}
		//		Base class for all actions working on selected elements
		class ActOnSelectionMenuItem extends MenuItem {
			constructor(mnId, tool, label, icon, iconStyle, menuBlock, right, toolTip) {
				super(mnId, tool, label, icon, iconStyle, menuBlock, right, false, toolTip);
			}
			update() {
				this.DN4.menu.enableItem(this.Id, this.DN4.draw.currentSelection.length > 0);
			}
		}
		//		-- MI_DEL --
		class DelMenuItem extends ActOnSelectionMenuItem {
			constructor(mnId, tool) {
				super(mnId, tool, "DEL", "E872", "", "mn_main", false, "Delete selected elements");
			}
			click(event) {
				this.DN4.model.removeSelectedElements();
			}
		}
		//		-- MI_PROP --
//		class PropertyMenuItem extends ActOnSelectionMenuItem {
		class PropertyMenuItem extends MenuItem {
			constructor(mnId, tool) {
				super(mnId, tool, "PROP.", "E429","", "mn_main", false, true, "Show properties for the selected elements");
			}
			click(event) {
				this.DN4.model.ShowPropertyDialog();
			}
			update() {
				this.DN4.menu.enableItem(this.Id, this.DN4.draw.currentSelection.length == 1);
			}
		}
		//		-- MI_ZOOM -- MI_SHIFT -- MI_PAN --
		class ZoomPanShiftMenuItem extends MenuItem {
			constructor(mnId, tool, label, icon, toolTip) {
				super(mnId, tool, label, icon, "", "mn_main", true, true, toolTip);
			}
			click(event) {
				this.DN4.menu.changeZoomPanShift(this.Id);
			}
		}
		//		-- MI_C_VIEW --
		class CenterViewMenuItem extends MenuItem {
			constructor(mnId, tool) {
				super(mnId, tool, "VIEW", "E3B4","", "mn_main", true, true, "Center view to see all elements");
			}
			click(event) {
				this.DN4.draw.centerView();
			}
		}
		//		-- MI_UNDO --
		class UndoMenuItem extends MenuItem {
			constructor(mnId, tool) {
				super(mnId, tool, "UNDO", "E166", "", "mn_main", true, false, "Undo last action");
			}
			click(event) {
				this.DN4.cmdHistory.doUndo();
				this.DN4.draw.drawView();
			}
			update() {
				this.DN4.menu.enableItem(this.Id, this.DN4.cmdHistory.canUndo());
			}
		}
		//		-- MI_REDO --
		class RedoMenuItem extends MenuItem {
			constructor(mnId, tool) {
				super(mnId, tool, "REDO", "E15A", "", "mn_main", true, false, "Redo last action undone");
			}
			click(event) {
				this.DN4.cmdHistory.doRedo();
				this.DN4.draw.drawView();
			}
			update() {
				this.DN4.menu.enableItem(this.Id, this.DN4.cmdHistory.canRedo());
			}
		}
		//		-- MI_MORE -- MI_LESS -- and other sub-menus
		class MenuChangeItem extends MenuItem {
			constructor(mnId, tool, label, icon, iconStyle, menuBlock, right, enabled, newMenuBlock, toolTip) {
				super(mnId, tool, label, icon, iconStyle, menuBlock, right, enabled, toolTip);
				this.newMenu = newMenuBlock;
			}
			click(event) {
				$("#"+this.menuBlk).hide();
				$("#"+this.newMenu).show();
			}
		}
		
		// -- MI_GRID -- MI_SNAP -- MI_ANCHOR -- MI_BOX_MODE -- and all option selectable
		class OptionMenuItem extends MenuItem {
			constructor(mnId, tool, label, icon, iconStyle, menuBlock, right, enabled, selected, trigRedraw, toolTip) {
				super(mnId, tool, label, icon, iconStyle, menuBlock, right, enabled, toolTip);
				// Check if the menu item is selected
				this.selected = selected;
				this.trigRedraw = trigRedraw;
				if(selected) {
					$("#"+mnId).addClass("selected");
				}

			}
			click(event) {
				this.DN4.menu.switchItemSelectedState(this.Id);
				if(this.trigRedraw) {
					this.DN4.draw.drawView();
				}
			}
		}
		//		-- MI_GRID_PLUS -- MI_GRID_MINUS --
		class GridPlusMinusMenuItem extends MenuItem {
			constructor(mnId, tool, label, icon, factor, toolTip) {
				super(mnId, tool, label, icon, "", "mn_more", false, false, toolTip);
				this.factor = factor;
			}
			click(event) {
				this.DN4.draw.gridSize = Math.round(this.DN4.draw.gridSize * this.factor);
				this.DN4.draw.drawView();
				this.DN4.menu.items["mi_grid_plus"].update();
				this.DN4.menu.items["mi_grid_mins"].update();
			}
			update() {
				var newSize = Math.round(this.DN4.draw.gridSize * this.factor);
				this.DN4.menu.enableItem(this.Id, (newSize > this.DN4.config.minGridSize) && 
												  (newSize < this.DN4.config.maxGridSize));
			}
		}
		//		-- MI_AL_xxx -- MI_DIS_xxx --
		class AlignMenuItem extends MenuItem {
			constructor(mnId, tool, label, icon, iconStyle, func, sub, axis, nnes, toolTip) {
				super(mnId, tool, label, icon, iconStyle, "mn_align", false, false, toolTip);
				this.func = func;
				this.sub  = sub;
				this.axis = axis;
				this.nnes = nnes;	// number of non-edge selected
			}
			click(event) {
				this.DN4.draw.applyAlignFunction(this.func, this.sub, this.axis);
			}
			update() {
				this.DN4.menu.enableItem(this.Id, this.DN4.draw.nonEdgesSelected.length > this.nnes);
			}
		}
		//		-- MI_ROT_xxx -- MI_FLIP_xxx --
		class QuickTransfMenuItem extends MenuItem {
			constructor(mnId, tool, label, icon, iconStyle, r, sx, sy, toolTip) {
				super(mnId, tool, label, icon, iconStyle, "mn_trans", false, false, toolTip);
				this.r  = r;
				this.sx = sx;
				this.sy = sy;
			}
			click(event) {
				this.DN4.draw.quickTransform(0, 0, this.r, this.sx, this.sy);
			}
			update() {
				this.DN4.menu.enableItem(this.Id, this.DN4.draw.nonEdgesSelected.length > 0);
			}
		}
		//		-- MI_SAVE --
		class SaveMenuItem extends MenuItem {
			constructor(mnId, tool) {
				super(mnId, tool, "SAVE", "E161","", "mn_file", false, true, "Save file - NOT REALLY IMPLEMENTED: now it just debug prints the model");
			}
			click(event) {
				this.DN4.model.SaveModelDialog();
			}
		}
		//		-- MI_DEBUG --
		class ShowDebugMenuItem extends MenuItem {
			constructor(mnId, tool) {
				super(mnId, tool, "DEBUG", "E868","", "mn_main", true, true, "Show the Debug window");
			}
			click(event) {
				this.DN4.model.DebugModelDialog(0);
			}
		}
					
		// menu item definitions (names must match the ID in the html page)
		this.items = [];
		
		// -- elements of Main menu (mn_main)
		this.items["mi_connsep"]  = new ConnSepMenuItem("mi_connsep", tool);
		this.items["mi_copy"]     = new ActOnSelectionMenuItem("mi_copy", tool, "COPY", "E14D","", "mn_main", false, "Copy selected elements - NOT IMPLEMENTED");
		this.items["mi_paste"]    = new MenuItem("mi_paste", tool, "PASTE", "E14F","", "mn_main", false, false, "Paste selected elements - NOT IMPLEMENTED");
		this.items["mi_cut"]      = new ActOnSelectionMenuItem("mi_cut", tool, "CUT", "E14E","", "mn_main", false, "Cut selected elements - NOT IMPLEMENTED");
		this.items["mi_del"]      = new DelMenuItem("mi_del", tool);
		this.items["mi_dup"]      = new ActOnSelectionMenuItem("mi_dup", tool, "DUP", "E401","", "mn_main", false, "Duplicate selected elements - NOT IMPLEMENTED");
		this.items["mi_prop"]     = new PropertyMenuItem("mi_prop", tool);
	
		this.items["mi_more"]     = new MenuChangeItem("mi_more", tool, "MORE", "E5D4","", "mn_main",
													   true, true, "mn_more", "Show more commands");
		this.items["mi_solve"] = new MenuItem("mi_solve", tool, "SOLVE", "E037","", "mn_main", true, false, "Solve model - NOT IMPLEMENTED");
		this.items["mi_redo"]     = new RedoMenuItem("mi_redo", tool);
		this.items["mi_undo"]     = new UndoMenuItem("mi_undo", tool);
		this.items["mi_shift"]    = new ZoomPanShiftMenuItem("mi_shift", tool, "SHIFT", "E148", "Emulate SHIFT pressure on keyboard");
		this.items["mi_pan"]      = new ZoomPanShiftMenuItem("mi_pan", tool, "PAN", "E89F", "Click and drag to pan view");
		this.items["mi_zoom"]     = new ZoomPanShiftMenuItem("mi_zoom", tool, "ZOOM", "E8FF", "Click and drag to zoom view");
		this.items["mi_c_view"]   = new CenterViewMenuItem("mi_c_view", tool);
		if(this.DN4.config.enableDebugButton)
			this.items["mi_debug"]   = new ShowDebugMenuItem("mi_debug", tool);


		// -- elements of More menu (mn_more)
		this.items["mi_grid_plus"]= new GridPlusMinusMenuItem("mi_grid_plus", tool, "GRID+", "E148", 2, "Increase grid size");
		this.items["mi_grid"]     = new OptionMenuItem("mi_grid", tool, "GRID", "E3EC","", "mn_more",
													   false, true, false, true, "Show / Hide grid");
		this.items["mi_grid_mins"]= new GridPlusMinusMenuItem("mi_grid_mins", tool, "GRID-", "E15D", 0.5, "Decrease grid size");
		this.items["mi_snap"]     = new OptionMenuItem("mi_snap", tool, "SNAP", "E41C","", "mn_more",
													   false, true, false, false, "Snap to grid ON/OFF");
		this.items["mi_anchor"]   = new OptionMenuItem("mi_anchor", tool, "ANCH.", "E157","", "mn_more",
													   false, true, true, false, "CAN'T REMEMBER WHAT THIS SHUOLD DO! Not implemented yet");


		this.items["mi_less"]     = new MenuChangeItem("mi_less", tool, "LESS", "E5D4","", "mn_more",
													   true, true, "mn_main", "Return to main menu");
		this.items["mi_align"]    = new MenuChangeItem("mi_align", tool, "ALIGN", "E234","", "mn_more",
													   true, true, "mn_align", "Show align menu");
		this.items["mi_trans"]    = new MenuChangeItem("mi_trans", tool, "TRANS.", "E428","", "mn_more",
													   true, true, "mn_trans", "Show quick transform menu");

		this.items["mi_settings"] = new MenuItem("mi_settings", tool, "SETT.", "E8B8","", "mn_more", true, false, "Edit tool settings - NOT IMPLEMENTED");

		this.items["mi_file"] = new MenuChangeItem("mi_file", tool, "FILE", "E2C7","", "mn_more", true, true, "mn_file", "Show File menu");

		// -- elements of Align menu (mn_align)
		this.items["mi_al_left"]  = new AlignMenuItem("mi_al_left", tool, "LEFT", "E236","",0,-1,"x",1, "Align selected elements to the LEFT");
		this.items["mi_al_center"]= new AlignMenuItem("mi_al_center", tool, "CENTER", "E234","",0,0,"x",1, "Align selected elements at CENTER");
		this.items["mi_al_right"] = new AlignMenuItem("mi_al_right", tool, "RIGHT", "E237","",0,1,"x",1, "Align selected elements to the RIGHT");
		this.items["mi_al_top"]   = new AlignMenuItem("mi_al_top", tool, "TOP", "E25A","",0,-1,"y",1, "Align selected elements to the TOP");
		this.items["mi_al_mid"]   = new AlignMenuItem("mi_al_mid", tool, "MID.", "E259","",0,0,"y",1, "Align selected elements to the MIDDLE (vertical center)");
		this.items["mi_al_bottom"]= new AlignMenuItem("mi_al_bottom", tool, "BOTT.", "E258","",0,1,"y",1, "Align selected elements to the BOTTOM");
		this.items["mi_dis_hor"]  = new AlignMenuItem("mi_dis_hor", tool, "DIS.H.", "E240",
												 " style=\"transform:rotate(-90deg)\"", 1,0, "x", 2, "Distribute selected elements HORIZONTALLY");
		this.items["mi_dis_ver"]  = new AlignMenuItem("mi_dis_ver", tool, "DIS.V.", "E240","", 1,0, "y", 2, "Distribute selected elements VERTICALLY");
		this.items["mi_al_qnt"]   = new AlignMenuItem("mi_al_qnt", tool, "SNAPSL", "E22D","", 10,0,"",0, "Snap to grid the position of the selected objects");
		this.items["mi_al_box"]   = new OptionMenuItem("mi_al_box", tool, "BOX_M.", "E835","", "mn_align",
													   false, true, false, false, "Turns box mode on during alignment: DON'T REMEMBER HOW IT SHOULD WORK, and NOT IMPLEMENTED yet");
		this.items["mi_al_canc"]  = new MenuChangeItem("mi_al_canc", tool, "CLOSE", "E5C9","", "mn_align",
													   true, true, "mn_more", "Return to previous menu");


		// -- elements of Quick Transform menu (mn_trans)
		this.items["mi_rot_cw"]   = new QuickTransfMenuItem("mi_rot_cw", tool, "CW", "E41A","", 1.570796326794897, 1, 1, "Rotate selection 90 deg. CLOCKWISE");
		this.items["mi_rot_ccw"]  = new QuickTransfMenuItem("mi_rot_ccw", tool, "CCW", "E419","", -1.570796326794897, 1, 1, "Rotate selection 90 deg. COUNTER-CLOCKWISE");
		this.items["mi_flip_hor"] = new QuickTransfMenuItem("mi_flip_hor", tool, "FLP.H.", "E3E8","", 0, -1, 1, "Flip selection HORIZONTALLY");
		this.items["mi_flip_ver"] = new QuickTransfMenuItem("mi_flip_ver", tool, "FLP.V.", "E3E8",
												 " style=\"transform:rotate(-90deg)\"", 0, 1, -1, "Flip selection VERTICALLY");
		this.items["mi_tran_canc"]= new MenuChangeItem("mi_tran_canc", tool, "CLOSE", "E5C9","", "mn_trans",
													   true, true, "mn_more", "Return to previous menu");
		// -- elements of File menu (mn_file)
		this.items["mi_new"] = new MenuItem("mi_new", tool, "NEW", "E873","", "mn_file", false, false, "New file - NOT IMPLEMENTED");		// Shows the main menu
		this.items["mi_load"] = new MenuItem("mi_load", tool, "LOAD", "EAF3","", "mn_file", false, false, "Load file - NOT IMPLEMENTED");		// Shows the main menu
		this.items["mi_save"] = new SaveMenuItem("mi_save", tool);		// Shows the main menu
		this.items["mi_saveAs"] = new MenuItem("mi_saveAs", tool, "SV.AS", "EB60","", "mn_file", false, false, "Save file as - NOT IMPLEMENTED");		// Shows the main menu
		this.items["mi_file_canc"]= new MenuChangeItem("mi_file_canc", tool, "CLOSE", "E5C9","", "mn_file",
													   true, true, "mn_more", "Return to previous menu");
		$("#mn_main").show();
	}

	// sends the update to all the menu items
	update() {
		for(var p in this.items) {
			this.items[p].update();
		}
	};

	// enables or disable a menu items
	enableItem(item, state) {
		if(state != this.items[item].enabled) {		// only if the state changes
			var el = "#"+item;
			if(state) {
				$(el).removeClass("disabled").addClass("enabled");
			} else {
				$(el).removeClass("enabled").addClass("disabled");
			}
			this.items[item].enabled = state;
		}
	};

	// switches the selected state of a toggle menu item
	switchItemSelectedState(item) {
		var el = "#"+item;
		if(this.items[item].selected) {
			$(el).removeClass("selected");
		} else {
			$(el).addClass("selected");
		}
		this.items[item].selected = !this.items[item].selected;
	};
	
	// sends the menu click
	click(item, event) {
		if(this.items[item].enabled) {		// sends click only to enabled items
			this.items[item].click(event);
		}
	}

	mouseover(item, event) {
		this.items[item].mouseover(event);
	}

	mouseout(item, event) {
		this.items[item].mouseout(event);
	}

	changeZoomPanShift(item, code) {
		var el = "#"+item;
		if(this.currentZoomPanShift == "none") {	// none is selected between zoom, pan or shift
			$(el).removeClass("enabled").addClass("selected");	// so activate it
			this.currentZoomPanShift = item;
		} else if(item == this.currentZoomPanShift) {	// the same button is press
			$(el).removeClass("selected").addClass("enabled");	// so deactivate it
			this.currentZoomPanShift = "none";
		} else {	// a different button has been pressed
			$("#"+this.currentZoomPanShift).removeClass("selected").addClass("enabled");	// deactivate the old
			$(el).removeClass("enabled").addClass("selected");	// activate the new
			this.currentZoomPanShift = item;
		}
	}
};