"use strict"	// temporary - for a better debugging

// A more complex refactoring for Advanced Manipulators using ES6 classes should be studied!
// I have tried but thing revealed to be more complex that hoped.
// For the moment we stick to objects having function attributes instead of classes to
// support advanced manipulators! But in the future this solution should be improved!

// this function encapsulates the meta-types of the graphic elements
class DN4_metaTypeElements {
	constructor(tool) {
	   // all the "closure" variables
		this.DN4 = tool;			// the variable to access all the other components of the gui
	
		// meta drawing elements
		// base class
		class MetaTypeElement{
			constructor(mtId, tool) {
				this.Id = mtId;
				this.DN4 = tool;
				// add the manipulators to the prototype
				this.manipulators = new ExtraGraph.ManipulatorHandlers(tool);
			}
			// draw the element
			draw(context, s, d) {
			}
			// check if a point belongs to the element
			isOver(s, d, x, y) {
				return false;
			}
			// checks if the element intersects a box
			selBox(s, d, x, y, w, h) {
				return false;
			}
			// draw the manipulators for the element
			drawManipulators(context, el) {
			}
			// recompute bounding box
			getBbox(s, d) {
				return {x:0, y:0, w:10, h:10};
			}	
			// apply the transofrmations to the element
			applyManip(transf, el) {
			}
			// creates a global undo for the element
			makeUndoObj(el) {
				return {cmd: "n"};
			}
		}
	
		class Node_MetaTypeElement extends MetaTypeElement {
			constructor(elId, tool) {
				super(elId, tool);
				
				// the manipulators
				class Node_Manipulator extends ExtraGraph.ManipulatorHandlers {
					constructor(tool) {
						super(tool);
					}
				// start manipulation (Node)
					start(x, y, shift, manip) {
						var i, j, k, points;
						var s = manip.el.s;
						var d = elementTypes[manip.el.t].d;
						var undObj;
						manip.strX = s.tx;
						manip.strY = s.ty;
						manip.strRot = s.rot;
						switch(manip.n) {
						  case 4:
						  					// for each in and out arc composed by more than one segment
						  	undObj = [{cmd: "p", el: manip.el, path: [],
						  			   more: [{path: ["tx"], val: s.tx},
						  			   		  {path: ["ty"], val: s.ty}]
						  			  }];
						  	j = 1;
							break;
						  case 3:			// x scale
						  case 5:
							manip.xSize = d.hbw;
							manip.delta = 7;
							manip.xDirX = Math.cos(s.rot) * (manip.n == 3 ? -1 : 1);
							manip.xDirY = Math.sin(s.rot) * (manip.n == 3 ? -1 : 1);
						  	undObj = [{cmd: "p", el: manip.el, path: ["sx"], val: s.sx}];
							break;
						  case 1:			// y scale
						  case 7:
							manip.ySize = d.hbh;
							manip.delta = 7;
							manip.yDirX = -Math.sin(s.rot) * (manip.n == 1 ? -1 : 1);
							manip.yDirY =  Math.cos(s.rot) * (manip.n == 1 ? -1 : 1);
						  	undObj = [{cmd: "p", el: manip.el, path: ["sy"], val: s.sy}];
							break;
						  case 0:			// x & y scale
						  case 2:
						  case 6:		
						  case 8:
							manip.delta = 7;
							manip.ySize = d.hbh;
							manip.xSize = d.hbw;
							manip.ratio = s.sx / s.sy;
							manip.xDirX =  Math.cos(s.rot) * ((manip.n == 0) || (manip.n == 6) ? -1 : 1);
							manip.xDirY =  Math.sin(s.rot) * ((manip.n == 0) || (manip.n == 6) ? -1 : 1);
							manip.yDirX = -Math.sin(s.rot) * ((manip.n == 0) || (manip.n == 2) ? -1 : 1);
							manip.yDirY =  Math.cos(s.rot) * ((manip.n == 0) || (manip.n == 2) ? -1 : 1);
						  	undObj = [{cmd: "p", el: manip.el, path: [],
						  			   more: [{path: ["sx"], val: s.sx},
						  			   		  {path: ["sy"], val: s.sy}]
						  			  }];
							break;
						  case 9:
						  	undObj = [{cmd: "p", el: manip.el, path: ["rot"], val: s.rot}];
							break;
						}			
						manip.inp = [];
						manip.inDx = [];
						manip.inDy = [];
						for(i = 0; i < s.in.length; i++) {
							points = graph[s.in[i]].s.points;
							manip.inp[i] = jQuery.extend(true, {}, points);
							undObj[j] = this.DN4.metaTypeElements[elementTypes[graph[s.in[i]].t].t].
											 makeUndoObj(graph[s.in[i]]);
							j++;
							var last = points.length-1;
							manip.inDx[i] = points[last].x2 - s.tx;
							manip.inDy[i] = points[last].y2 - s.ty;
						}
						manip.outp = [];
						manip.outDx = [];
						manip.outDy = [];
						for(i = 0; i < s.out.length; i++) {
							points = graph[s.out[i]].s.points;
							manip.outp[i] = jQuery.extend(true, {}, points);
							undObj[j] = this.DN4.metaTypeElements[elementTypes[graph[s.out[i]].t].t].
											 makeUndoObj(graph[s.out[i]]);
							j++;
							manip.outDx[i] = points[0].x1 - s.tx;
							manip.outDy[i] = points[0].y1 - s.ty;
						}
					  	this.DN4.cmdHistory.setCurrUndo(undObj);
					}
					// move manipulator (Node)
					move(x, y, shift, manip) {
						var i, j, points, last;
						var s = manip.el.s;
						var redObj;
						var cx = s.tx;
						var cy = s.ty;
						var crt = 0;
						switch(manip.n) {
						  case 4:			// traslation
//// SNAP SUPPORT ?
						  	cx = ExtraGraph.snap(x);
						  	cy = ExtraGraph.snap(y);
//// SNAP SUPPORT ? (END)
							if(shift) {
								if(Math.abs(cx - manip.strX) >
								   Math.abs(cy - manip.strY)) {
									cy = manip.strY;
								} else {
									cx = manip.strX;
								}
							}
							redObj = [{cmd: "p", el: manip.el, path: [],
									   more: [{path: ["tx"], val: cx},
											  {path: ["ty"], val: cy}]
								  }];
							break;
						  case 9:			// rotation
//// SNAP SUPPORT ?
						  	var ang = ExtraGraph.snapAngle(x - s.tx, s.ty - y);
//// SNAP SUPPORT ? (END)
						  	redObj = [{cmd: "p", el: manip.el, path: ["rot"],
						  			   val: ang}];
							crt = ang - manip.strRot;
							break;
						  case 3:			// x scale
						  case 5:
						  	var len = (x - s.tx) * manip.xDirX + (y - s.ty) * manip.xDirY - manip.delta;
						  	var fact = ExtraGraph.snapScale(len / manip.xSize);
						  	if(len > 0) {
							  	redObj = [{cmd: "p", el: manip.el, path: ["sx"], val: fact}];
						  	} else {
						  		redObj = false;
						  	}
						  	break;
						  case 1:			// y scale
						  case 7:
						  	var len = (x - s.tx) * manip.yDirX + (y - s.ty) * manip.yDirY - manip.delta;
						  	var fact = ExtraGraph.snapScale(len / manip.ySize);
						  	if(len > 0) {
							  	redObj = [{cmd: "p", el: manip.el, path: ["sy"], val: fact}];
						  	} else {
						  		redObj = false;
						  	}
						  	break;
						  case 0:			// x & y scale
						  case 2:
						  case 6:		
						  case 8:
						  	var lenx = (x - s.tx) * manip.xDirX + (y - s.ty) * manip.xDirY - manip.delta;
						  	var leny = (x - s.tx) * manip.yDirX + (y - s.ty) * manip.yDirY - manip.delta;
						  	var factX = ExtraGraph.snapScale(lenx / manip.xSize);
						  	var factY = ExtraGraph.snapScale(leny / manip.xSize);
						  	var factYR = ExtraGraph.snapScale(lenx / manip.xSize / manip.ratio);
						  	if(shift) {
							  	if(lenx > 0) {
								  	redObj = [{cmd: "p", el: manip.el, path: [],
								  			   more: [{path: ["sx"], val: factX},
								  			   		  {path: ["sy"], val: factYR}]
							  			  }];
							  	} else {
							  		redObj = false;
							  	}
						  	} else {
							  	redObj = [{cmd: "p", el: manip.el, path: [],
							  			   more: [{path: ["sx"], val: s.sx},
							  			   		  {path: ["sy"], val: s.sy}]
						  			  }];
							  	if(lenx > 0) {
							  		redObj[0].more[0].val = factX;
							  	}
							  	if(leny > 0) {
							  		redObj[0].more[1].val = factY;
							  	}
						  	}
						  	break;
						}
						
						j = 1;
						// Adjust connections
						for(i = 0; i < s.in.length; i++) {
							redObj[j] = {cmd: "p", el: graph[s.in[i]], path: ["points"], more: []};
							points = graph[s.in[i]].s.points;
							last = points.length-1;
							var nx = cx + manip.inDx[i] * Math.cos(crt) -
										  manip.inDy[i] * Math.sin(crt);
							var ny = cy + manip.inDy[i] * Math.cos(crt) +
										  manip.inDx[i] * Math.sin(crt);
//console.log(nx + " " + manip.inp[i][last].x2 + " " + s.tx + " " + (manip.inp[i][last].x2 - s.tx) + " " + (x + manip.inp[i][last].x2 - s.tx));
							ExtraGraph.expandEdge(manip.inp[i], last, redObj[j].more,
													manip.inp[i][0].x1,
													manip.inp[i][0].y1,
													nx, ny);
							j++;
						}
						for(i = 0; i < s.out.length; i++) {
							redObj[j] = {cmd: "p", el: graph[s.out[i]], path: ["points"], more: []};
							points = graph[s.out[i]].s.points;
							last = points.length-1;
//							var nx = cx + manip.outDx[i];
//							var ny = cy + manip.outDy[i];
							var nx = cx + manip.outDx[i] * Math.cos(crt) -
										  manip.outDy[i] * Math.sin(crt);
							var ny = cy + manip.outDy[i] * Math.cos(crt) +
										  manip.outDx[i] * Math.sin(crt);
							ExtraGraph.expandEdge(manip.outp[i], last, redObj[j].more,
													nx, ny,
													manip.outp[i][last].x2,
													manip.outp[i][last].y2);
							j++;
						}
		//alert(redObj[0].more[0].val + " " + (lenx / manip.xSize) + " " + 
		//redObj[0].more[1].val + " " + (lenx / manip.ySize));
					  	this.DN4.cmdHistory.execWithHistory(redObj);
					}
					// end manipulation (Node)
					end(x, y, shift, manip) {
						switch(manip.n) {
						  case 0:
						  case 1:
						  case 2:
						  case 3:
						  case 5:
						  case 6:
						  case 7:
						  case 8:
							this.DN4.cmdHistory.putInHistory("Resize node");
							break;
						  case 4:
							this.DN4.cmdHistory.putInHistory("Move node");
						  	break;
						  case 9:
							this.DN4.cmdHistory.putInHistory("Rotate node");
						  	break;
						}
						this.DN4.menu.update();
					}
				// enters the advanced manipulators (Node)
					enterAdvanced(manip) {
						return false;	// no advanced manipulation yet
					}
					getManipulatorTooltip(el, manip) {
						var out = "";
						switch(manip) {
						  case 4:
							out = "Drag: Move, + SHIFT: Single Direction";
							break;
						  case 1:
						  case 7:
							out = "Drag: Vertical scaling";
							break;
						  case 3:
						  case 5:
							out = "Drag: Horizontal scaling";
							break;
						  case 0:
						  case 2:
						  case 6:
						  case 8:
							out = "Drag: Free Scaling, + SHIFT: Proportional";
							break;
						  case 9:
							out = "Drag: Rotate";
							break;
						  default:
							out = "Error!";
							break;
						}
						return out;
					}
				}
				
				this.manipulators = new Node_Manipulator(tool);	
			}
			
			// draw the element (Node)
			draw(context, s, d) {	// s -> element  properties
									// d -> metatype properties
				context.save();					// sets the transformations
				context.translate(s.tx, s.ty);
				context.rotate(s.rot);
				context.scale(s.sx, s.sy);
				ExtraGraph.drawNode(context, s, d);
			  	context.restore();
			};
			// check if a point belongs to the element (Node)
			isOver(s, d, x, y) {
				var t1_x = x - s.tx;	// invert translation
				var t1_y = y - s.ty;
				var tr_x = t1_x * Math.cos(s.rot) + t1_y * Math.sin(s.rot);	// invert rotation
				var tr_y = t1_y * Math.cos(s.rot) - t1_x * Math.sin(s.rot);
				tr_x = tr_x / s.sx;  tr_y = tr_y / s.sy; // invert scaling
		//this.DN4.draw.context.clearRect(0,0,100,30);
		//ExtraGraph.centerText(50, 32, (Math.round(tr_x*10)/10) + "," + (Math.round(tr_y*10)/10), "black", 16);
		
				// checks if it is inside the square that represents the node
				return ((tr_x > -d.hbw) && (tr_y > -d.hbh) && (tr_x < d.hbw) && (tr_y < d.hbh));
			}
			// checks if the element intersects a box (Node)
			selBox(s, d, x, y, w, h) {
				return ((s.tx >= x) && (s.ty >= y) && (s.tx <= x + w) && (s.ty <= y + h));
			}
			// draw the manipulators for the element (Node)
			drawManipulators(context, el) {	// el = the element
				var s = el.s;						// gets the element properties
				var d = elementTypes[el.t].d;
				context.save();					// sets the transformations
				context.strokeStyle = "#0077ff";	//  sets the color
				context.fillStyle   = "#ffffff";	//  sets the color
		
				// draw the manipulators
				ExtraGraph.drawManipulatorRect(s.tx, s.ty, s.rot, d.hbw * s.sx, d.hbh * s.sy,
											   el, this.manipulators, this.DN4.draw);
		
			  	context.restore();
			}
			// recompute bounding box (Node)
			getBbox(s, d) {
				var sx = d.hbw * (Math.abs(Math.cos(s.rot)) * s.sx + Math.abs(Math.sin(s.rot)) * s.sy);
				var sy = d.hbh * (Math.abs(Math.sin(s.rot)) * s.sx + Math.abs(Math.cos(s.rot)) * s.sy);
				return {x:s.tx - sx, y:s.ty - sy, w:2*sx, h:2*sy};
			}
			// apply the transofrmations to the element
			applyManip(transf, el) {
				var i, es, el, ed, points, xo, yo, xn, yn, last, k;
				var s = el.s;						// gets the element properties
				var out;
													// applys the transforms: translation
				var tp = ExtraGraph.transformPoint(s.tx, s.ty, this.DN4.draw.groupManType, transf);
				out = [{cmd: "p", el: el, path: [],
					    more: [{path: ["tx"], val: tp.x},
			  		 		   {path: ["ty"], val: tp.y}]}];
				
//console.log(tp.x + " " + s.tx + " " + tp.y + " " + s.ty + " " + this.DN4.draw.groupManType + " " + JSON.stringify(transf));	
//				var tpDx = tp.x - s.tx;
//				var tpDy = tp.y - s.ty;
//console.log(tpDx + " " + tpDy);	

				if(this.DN4.draw.groupManType != 1) {	// if rotation and scale of elements is considered
									// applys the transforms: scale
					out[0].more[2] = {path: ["sx"], val: s.sx * transf.d_lx};
					out[0].more[3] = {path: ["sy"], val: s.sy * transf.d_ly};	
									// applys the transforms: rotation
					out[0].more[4] = {path: ["rot"], val: s.rot + transf.d_rot};	
				}
		
				k = 1;
				for(i = 0; i < s.in.length; i++) {
					el = graph[s.in[i]];
					es = el.s;
					if(!es.selected) {
						out[k] = {cmd: "p", el: el, path: ["points"], more: []};
						points = es.points;
						last = points.length-1;
						xo = points[0].x1;
						yo = points[0].y1;
						tp = ExtraGraph.transformPoint(points[last].x2, points[last].y2, this.DN4.draw.groupManType, transf);
//console.log("f(" + tp.x + ", " + tp.y + ")  nf(" + points[last].x2 + ", " + points[last].y2 + ")");
						xn = tp.x;
						yn = tp.y;
						ExtraGraph.expandEdge(points, last, out[k].more, xo, yo, xn, yn);
						k++;
					}
				}
				for(i = 0; i < s.out.length; i++) {
					el = graph[s.out[i]];
					es = el.s;
					if(!es.selected) {
						out[k] = {cmd: "p", el: el, path: ["points"], more: []};
						points = es.points;
						last = points.length-1;
						xo = points[last].x2;
						yo = points[last].y2;
						tp = ExtraGraph.transformPoint(points[0].x1, points[0].y1, this.DN4.draw.groupManType, transf);
						xn = tp.x;
						yn = tp.y;
						ExtraGraph.expandEdge(points, last, out[k].more, xn, yn, xo, yo);
						k++;
					}
				}
				return out;
			}
			// creates a global undo for the element
			makeUndoObj(el) {
				return {cmd: "p", el: el, path: [],
			  			more: [{path: ["tx"], val: el.s.tx},
			  		 		   {path: ["ty"], val: el.s.ty},
			  		 		   {path: ["sx"], val: el.s.sx},
			  		 		   {path: ["sy"], val: el.s.sy},
			  		 		   {path: ["rot"], val: el.s.rot}]
			  			  };
			}
		}
		
		// the node meta type
		this.n = new Node_MetaTypeElement("n", tool);


	class Edge_MetaTypeElement extends MetaTypeElement {
		constructor(elId, tool) {
			super(elId, tool);
			
			// the manipulators
			class Edge_Manipulator extends ExtraGraph.ManipulatorHandlers {
				constructor(tool) {
					super(tool);
				}
				start(x, y, shift, manip) {
					var i = Math.floor(manip.n / 7);
					var pts = manip.el.s.points;
					var v = manip.n % 7;
					var undObj;
					switch(v) {
					  case 1:
						if((i > 0) && (manip.el.s.points[i].t1 & 4)) {
						  	undObj = [{cmd: "p", el: manip.el, path: ["points"], more: [
						  		  {path: [i-1],
					  			   more: [{path: ["xc2"], val: pts[i-1].xc2},
					  			   		  {path: ["yc2"], val: pts[i-1].yc2},
					  			   		  {path: ["x2"], val: pts[i-1].x2},
					  			   		  {path: ["y2"], val: pts[i-1].y2}]
					  			  }, {path: [i],
					  			   more: [{path: ["xc1"], val: pts[i].xc1},
					  			   		  {path: ["yc1"], val: pts[i].yc1},
					  			   		  {path: ["x1"], val: pts[i].x1},
					  			   		  {path: ["y1"], val: pts[i].y1}]
					  			  }]}];
						} else {
					  		undObj = [{cmd: "p", el: manip.el, path: ["points", i],
					  			   more: [{path: ["xc1"], val: pts[i].xc1},
					  			   		  {path: ["yc1"], val: pts[i].yc1},
					  			   		  {path: ["x1"], val: pts[i].x1},
					  			   		  {path: ["y1"], val: pts[i].y1}]
					  			  }];
						}					
						break;
					  case 3:
						if((i > 0) && (manip.el.s.points[i].t1 & 1)) {
						  	undObj = [{cmd: "p", el: manip.el, path: ["points"], more: [
						  		  {path: [i-1],
					  			   more: [{path: ["xc2"], val: pts[i-1].xc2},
					  			   		  {path: ["yc2"], val: pts[i-1].yc2}]
					  			  }, {path: [i],
					  			   more: [{path: ["xc1"], val: pts[i].xc1},
					  			   		  {path: ["yc1"], val: pts[i].yc1}]
					  			  }]}];
						} else {
					  		undObj = [{cmd: "p", el: manip.el, path: ["points", i],
					  			   more: [{path: ["xc1"], val: pts[i].xc1},
					  			   		  {path: ["yc1"], val: pts[i].yc1}]
					  			  }];
						}					
						break;
					  case 4:
						if((i < pts.length-1) && (pts[i].t2 & 1)) {
						  	undObj = [{cmd: "p", el: manip.el, path: ["points"], more: [
						  		  {path: [i+1],
					  			   more: [{path: ["xc1"], val: pts[i+1].xc1},
					  			   		  {path: ["yc1"], val: pts[i+1].yc1}]
					  			  }, {path: [i],
					  			   more: [{path: ["xc2"], val: pts[i].xc2},
					  			   		  {path: ["yc2"], val: pts[i].yc2}]
					  			  }]}];
						} else {
					  		undObj = [{cmd: "p", el: manip.el, path: ["points", i],
					  			   more: [{path: ["xc2"], val: pts[i].xc2},
					  			   		  {path: ["yc2"], val: pts[i].yc2}]
					  			  }];
						}
						break;
					  case 2:
						if((i < pts.length-1) && (pts[i].t2 & 4)) {
						  	undObj = [{cmd: "p", el: manip.el, path: ["points"], more: [
						  		  {path: [i+1],
					  			   more: [{path: ["xc1"], val: pts[i+1].xc1},
					  			   		  {path: ["yc1"], val: pts[i+1].yc1},
					  			   		  {path: ["x1"], val: pts[i+1].x1},
					  			   		  {path: ["y1"], val: pts[i+1].y1}]
					  			  }, {path: [i],
					  			   more: [{path: ["xc2"], val: pts[i].xc2},
					  			   		  {path: ["yc2"], val: pts[i].yc2},
					  			   		  {path: ["x2"], val: pts[i].x2},
					  			   		  {path: ["y2"], val: pts[i].y2}]
					  			  }]}];
						} else {
					  		undObj = [{cmd: "p", el: manip.el, path: ["points", i],
					  			   more: [{path: ["xc2"], val: pts[i].xc2},
					  			   		  {path: ["yc2"], val: pts[i].yc2},
					  			   		  {path: ["x2"], val: pts[i].x2},
					  			   		  {path: ["y2"], val: pts[i].y2}]
					  			  }];
						}
						break;
					}
				  	this.DN4.cmdHistory.setCurrUndo(undObj);
				}
			// move manipulator (Edge)
				move(x, y, shift, manip) {
					var i = Math.floor(manip.n / 7);
					var pts = manip.el.s.points;
					var v = manip.n % 7;
					var redObj;
//// SNAP SUPPORT ?
						  	x = ExtraGraph.snap(x);
						  	y = ExtraGraph.snap(y);
//// SNAP SUPPORT ? (END)
					switch(v) {
					  case 1:
						if((i > 0) && (pts[i].t1 & 4)) {
						  	redObj = [{cmd: "p", el: manip.el, path: ["points"], more: [
						  		  {path: [i-1],
					  			   more: [{path: ["xc2"], val: pts[i-1].xc2 + x -
					  			   							   pts[i-1].x2},
					  			   		  {path: ["yc2"], val: pts[i-1].yc2 + y -
					  			   		  					   pts[i-1].y2},
					  			   		  {path: ["x2"], val: x},
					  			   		  {path: ["y2"], val: y}]
					  			  }, {path: [i],
					  			   more: [{path: ["xc1"], val: pts[i].xc1 + x -
					  			   							   pts[i].x1},
					  			   		  {path: ["yc1"], val: pts[i].yc1 + y -
					  			   		  					   pts[i].y1},
					  			   		  {path: ["x1"], val: x},
					  			   		  {path: ["y1"], val: y}]
					  			  }]}];
						} else {
					  		redObj = [{cmd: "p", el: manip.el, path: ["points", i],
					  			   more: [{path: ["xc1"], val: pts[i].xc1 + x -
					  			   							   pts[i].x1},
					  			   		  {path: ["yc1"], val: pts[i].yc1 + y -
					  			   		  					   pts[i].y1},
					  			   		  {path: ["x1"], val: x},
					  			   		  {path: ["y1"], val: y}]
					  			  }];
						}					
						break;
					  case 3:
						if((i > 0) && (pts[i].t1 & 1)) {
						  	redObj = [{cmd: "p", el: manip.el, path: ["points"], more: [
						  		  {path: [i-1],
					  			   more: [{path: ["xc2"], val: pts[i].x1 - x +
					  			   							   pts[i-1].x2},
					  			   		  {path: ["yc2"], val: pts[i].y1 - y +
					  			   		  					   pts[i-1].y2}]
					  			  }, {path: [i],
					  			   more: [{path: ["xc1"], val: x},
					  			   		  {path: ["yc1"], val: y}]
					  			  }]}];
						} else {
					  		redObj = [{cmd: "p", el: manip.el, path: ["points", i],
					  			   more: [{path: ["xc1"], val: x},
					  			   		  {path: ["yc1"], val: y}]
					  			  }];
						}					
						break;
					  case 4:
						if((i < pts.length-1) && (pts[i].t2 & 1)) {
						  	redObj = [{cmd: "p", el: manip.el, path: ["points"], more: [
						  		  {path: [i+1],
					  			   more: [{path: ["xc1"], val: pts[i].x2 - x +
					  			   							   pts[i+1].x1},
					  			   		  {path: ["yc1"], val: pts[i].y2 - y +
					  			   		  					   pts[i+1].y1}]
					  			  }, {path: [i],
					  			   more: [{path: ["xc2"], val: x},
					  			   		  {path: ["yc2"], val: y}]
					  			  }]}];
						} else {
					  		redObj = [{cmd: "p", el: manip.el, path: ["points", i],
					  			   more: [{path: ["xc2"], val: x},
					  			   		  {path: ["yc2"], val: y}]
					  			  }];
						}
						break;
					  case 2:
						if((i < pts.length-1) && (pts[i].t2 & 4)) {
						  	redObj = [{cmd: "p", el: manip.el, path: ["points"], more: [
						  		  {path: [i+1],
					  			   more: [{path: ["xc1"], val: pts[i+1].xc1 + x -
					  			   							   pts[i+1].x1},
					  			   		  {path: ["yc1"], val: pts[i+1].yc1 + y -
					  			   		  					   pts[i+1].y1},
					  			   		  {path: ["x1"], val: x},
					  			   		  {path: ["y1"], val: y}]
					  			  }, {path: [i],
					  			   more: [{path: ["xc2"], val: pts[i].xc2 + x -
					  			   							   pts[i].x2},
					  			   		  {path: ["yc2"], val: pts[i].yc2 + y -
					  			   		  					   pts[i].y2},
					  			   		  {path: ["x2"], val: x},
					  			   		  {path: ["y2"], val: y}]
					  			  }]}];
						} else {
					  		redObj = [{cmd: "p", el: manip.el, path: ["points", i],
					  			   more: [{path: ["xc2"], val: pts[i].xc2 + x -
					  			   							   pts[i].x2},
					  			   		  {path: ["yc2"], val: pts[i].yc2 + y -
					  			   		  					   pts[i].y2},
					  			   		  {path: ["x2"], val: x},
					  			   		  {path: ["y2"], val: y}]
					  			  }];
						}
						break;
					}
				  	this.DN4.cmdHistory.execWithHistory(redObj);
				}
				// end manipulation (Edge)
				end(x, y, shift, manip) {
					var v = manip.n % 7;
					switch(v) {
					  case 1:
					  case 2:
						this.DN4.cmdHistory.putInHistory("Move edge point");
						break;
					  case 3:
					  case 4:
						this.DN4.cmdHistory.putInHistory("Move edge tangent");
					  	break;
					}
					this.DN4.menu.update();
				}
				// enters the advanced manipulators (Edge)
				enterAdvanced(manip) {
					var i = Math.floor(manip.n / 7);
					var pts = manip.el.s.points;
					var v = manip.n % 7;
					var iD = this.DN4;	// to allow use inside sub-objects
					switch(v) {
					  case 1:
						if(i > 0) {
							iD.draw.advancedManipulatorMenu = {
								x: pts[i].x1 + 40,
								y: pts[i].y1,
								w: 6,
								items: [ {label: "Curve", act: function() {
									var dxi, dyi, dxi1, dyi1, l, bx, by;
									dxi  = pts[i].x2   - pts[i].x1;
									dyi  = pts[i].y2   - pts[i].y1;
									dxi1 = pts[i-1].x1 - pts[i-1].x2;
									dyi1 = pts[i-1].y1 - pts[i-1].y2;
									if(((dxi != 0) || (dyi != 0)) && ((dxi1 != 0) || (dyi1 != 0))) {
										l = Math.sqrt(dxi*dxi+dyi*dyi);
										dxi /= l; dyi /= l;
										l = Math.sqrt(dxi1*dxi1+dyi1*dyi1);
										dxi1 /= l; dyi1 /= l;
										bx = dxi+dxi1; by = dyi+dyi1;
										l = Math.sqrt(bx*bx+by*by);
										bx /= l; by /= l;
										l = bx * dxi + by * dyi;
										bx *= l; by *= l;			// projection of the half-vector
										dxi  -= bx; dyi  -= by; 
										dxi1 -= bx; dyi1 -= by;
										
										l = 50;		// arbitrary len for new tangent
		
										iD.cmdHistory.addAndExec("Curve", 
											[{cmd: "p", el: manip.el,		// undo
											   path: ["points"], more: [{path:[i],
								  			     more: [{path: ["xc1"], val: pts[i].xc1},
								  			   		    {path: ["yc1"], val: pts[i].yc1}]},
								  			   		    {path:[i-1],
								  			     more: [{path: ["xc2"], val: pts[i-1].xc2},
								  			   		    {path: ["yc2"], val: pts[i-1].yc2}]}]
								  			  }],
								  			[{cmd: "p", el: manip.el,	// command
											   path: ["points"], more: [{path:[i],
								  			     more: [{path: ["xc1"], val: pts[i].x1 - dxi*l},
								  			   		    {path: ["yc1"], val: pts[i].y1 - dyi*l}]},
								  			   		    {path:[i-1],
								  			     more: [{path: ["xc2"], val: pts[i-1].x2 - dxi1*l},
								  			   		    {path: ["yc2"], val: pts[i-1].y2 - dyi1*l}]}]
								  			  }]);
									}
								  return false;
								  }},
								  (pts[i].t1 & 4 ?
								    {label: "Unlock pos.", act: function() {
								    	var l = 10; // arbitrary delta added to x during split
										iD.cmdHistory.addAndExec("Unlock Position", 
											[{cmd: "p", el: manip.el,		// undo
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t1"], val: pts[i].t1},
											            {path: ["x1"], val: pts[i].x1},
											            {path: ["xc1"], val: pts[i].xc1}]},
											    {path: [i-1],
											     more: [{path: ["t2"], val: pts[i-1].t2},
											            {path: ["x2"], val: pts[i-1].x2},
											            {path: ["xc2"], val: pts[i-1].xc2}]}]}],
								  			[{cmd: "p", el: manip.el,	// command
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t1"], val: pts[i].t1&3},
											            {path: ["x1"], val: pts[i].x1-l},
											            {path: ["xc1"], val: pts[i].xc1-l}]},
											    {path: [i-1],
											     more: [{path: ["t2"], val: pts[i-1].t2&3},
											            {path: ["x2"], val: pts[i-1].x2+l},
											            {path: ["xc2"], val: pts[i-1].xc2+l}]}]}]
								  			  );
								    	return false;
								    	}} :
								    {label: "Lock pos.", act: function() {
								    	var dx = (pts[i].x1 - pts[i-1].x2)/2;
								    	var dy = (pts[i].y1 - pts[i-1].y2)/2;
										iD.cmdHistory.addAndExec("Lock Position", 
											[{cmd: "p", el: manip.el,		// undo
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t1"], val: pts[i].t1},
											            {path: ["x1"], val: pts[i].x1},
											            {path: ["xc1"], val: pts[i].xc1},
											            {path: ["y1"], val: pts[i].y1},
											            {path: ["yc1"], val: pts[i].yc1}]},
											    {path: [i-1],
											     more: [{path: ["t2"], val: pts[i-1].t2},
											            {path: ["x2"], val: pts[i-1].x2},
											            {path: ["xc2"], val: pts[i-1].xc2},
											            {path: ["y2"], val: pts[i-1].y2},
											            {path: ["yc2"], val: pts[i-1].yc2}]}]}],
								  			[{cmd: "p", el: manip.el,	// command
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t1"], val: pts[i].t1|4},
											            {path: ["x1"], val: pts[i].x1-dx},
											            {path: ["xc1"], val: pts[i].xc1-dx},
											            {path: ["y1"], val: pts[i].y1-dy},
											            {path: ["yc1"], val: pts[i].yc1-dy}]},
											    {path: [i-1],
											     more: [{path: ["t2"], val: pts[i-1].t2|4},
											            {path: ["x2"], val: pts[i-1].x2+dx},
											            {path: ["xc2"], val: pts[i-1].xc2+dx},
											            {path: ["y2"], val: pts[i-1].y2+dy},
											            {path: ["yc2"], val: pts[i-1].yc2+dy}]}]}]
								  			  );
										return false;
										}}),
									{label: "Remove", act: function() {
										iD.cmdHistory.addAndExec("Remove curve point", 
											[{cmd: "p", el: manip.el,	// undo
											   path: ["points"],
								  			   add:  i
								  			 },
								  			 {cmd: "p", el: manip.el,		
											   path: ["points"],
											   more:[{
											   	 path: [i],
								  			     more: [{path: ["x1"],  val: pts[i].x1},
													    {path: ["y1"],  val: pts[i].y1},
													    {path: ["xc1"], val: pts[i].xc1},
													    {path: ["yc1"], val: pts[i].yc1},
													    {path: ["t1"],  val: pts[i].t1},
													    {path: ["x2"],  val: pts[i].x2},
													    {path: ["y2"],  val: pts[i].y2},
													    {path: ["xc2"], val: pts[i].xc2},
													    {path: ["yc2"], val: pts[i].yc2},
													    {path: ["t2"],  val: pts[i].t2}
								  			   		   ]},{
											   	 path: [i-1],
								  			     more: [{path: ["x2"],  val: pts[i-1].x2},
													    {path: ["y2"],  val: pts[i-1].y2},
													    {path: ["xc2"], val: pts[i-1].xc2},
													    {path: ["yc2"], val: pts[i-1].yc2},
													    {path: ["t2"],  val: pts[i-1].t2}
								  			   		   ]}
								  			   		]
								  			  }],
								  			[{cmd: "p", el: manip.el,		// undo
											   path: ["points", i-1],
								  			   more: [{path: ["x2"],  val: pts[i].x2},
								  			   		  {path: ["y2"],  val: pts[i].y2},
								  			   		  {path: ["xc2"], val: pts[i].xc2},
								  			   		  {path: ["yc2"], val: pts[i].yc2},
								  			   		  {path: ["t2"],  val: pts[i].t2}]
								  			 },
								  			 {cmd: "p", el: manip.el,	// command
											   path: ["points"],
								  			   rem:  i
								  			 }]);
							 return false;
							 }}, {label: "Add", act: function() {
								 return iD.FSM.GS_ADDINTPOINT;
							 }}
								 ]};
		//					alert("Entering advanced manipulators, 1st veretx, intermediate point ");
						} else {
		//					alert("Entering advanced manipulators, start point ");
							iD.draw.advancedManipulatorMenu = {
								x: pts[i].x1 + 40,
								y: pts[i].y1,
								w: 6,
								items: [ {label: "Curve", act: function() {
									var dxi, dyi, l;
									dxi = pts[i].x1 - pts[i].x2;
									dyi = pts[i].y1 - pts[i].y2;
									if((dxi != 0) || (dyi != 0)) {
										l = Math.sqrt(dxi*dxi+dyi*dyi);
										dxi /= l; dyi /= l;
										
										l = 50;		// arbitrary len for new tangent
		
										iD.cmdHistory.addAndExec("Curve", 
											[{cmd: "p", el: manip.el,		// undo
											   path: ["points", i], 
								  			     more: [{path: ["xc1"], val: pts[i].xc1},
								  			   		    {path: ["yc1"], val: pts[i].yc1}]
								  			  }],
								  			[{cmd: "p", el: manip.el,	// command
											   path: ["points", i],
								  			     more: [{path: ["xc1"], val: pts[i].x1 - dxi*l},
								  			   		    {path: ["yc1"], val: pts[i].y1 - dyi*l}]
								  			  }]);
									}
								    return false;
								  }}, {label: "Add", act: function() {
										 return iD.FSM.GS_ADDINTPOINT;
								  }}
								 ]};
						}
						return this.DN4.FSM.GS_ADVMENUSHOWN;
						break;
					  case 3:
						iD.draw.advancedManipulatorMenu = {
							x: pts[i].xc1 + 40,
							y: pts[i].yc1,
							w: 6,
							items: [ {label: "Remove", act: function() {
								iD.cmdHistory.addAndExec("Remove tangent", 
											[{cmd: "p", el: manip.el,		// undo
											   path: ["points", i],
								  			   more: [{path: ["xc1"], val: pts[i].xc1},
								  			   		  {path: ["yc1"], val: pts[i].yc1}]
								  			  }],
								  			[{cmd: "p", el: manip.el,	// command
											   path: ["points", i],
								  			   more: [{path: ["xc1"], val: pts[i].x1},
								  			   		  {path: ["yc1"], val: pts[i].y1}]
								  			  }]);
							 return false;
							 }}
							]
						};
						if(i > 0) {
		//					alert("Entering advanced manipulators, 1st control, intermediate point ");
							iD.draw.advancedManipulatorMenu.items[1] =
								  (pts[i].t1 & 1 ?
								    {label: "Unlock tan.", act: function() {
								    	var l = 10; // arbitrary delta added to x during split
										iD.cmdHistory.addAndExec("Unlock Tangent", 
											[{cmd: "p", el: manip.el,		// undo
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t1"], val: pts[i].t1}]},
											    {path: [i-1],
											     more: [{path: ["t2"], val: pts[i-1].t2}]}]}],
								  			[{cmd: "p", el: manip.el,	// command
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t1"], val: pts[i].t1&6}]},
											    {path: [i-1],
											     more: [{path: ["t2"], val: pts[i-1].t2&6}]}]}]
								  			  );
								    	return false;
								    	}} :
								    {label: "Lock tan.", act: function() {
										iD.cmdHistory.addAndExec("Lock Tangent", 
											[{cmd: "p", el: manip.el,		// undo
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t1"],  val: pts[i].t1}]},
											    {path: [i-1],
											     more: [{path: ["t2"],  val: pts[i-1].t2},
											     		{path: ["xc2"], val: pts[i-1].x2},
								  			   		    {path: ["yc2"], val: pts[i-1].y2}]}]}],
								  			[{cmd: "p", el: manip.el,	// command
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t1"], val: pts[i].t1|1}]},
											    {path: [i-1],
											     more: [{path: ["t2"],  val: pts[i-1].t2|1},
											     		{path: ["xc2"], val: pts[i-1].x2 + 
											     							 pts[i].x1 - pts[i].xc1},
								  			   		    {path: ["yc2"], val: pts[i-1].y2 + 
											     							 pts[i].y1 - pts[i].yc1}]}]}]
								  			  );
								  		return false;
										}});
						} else {
		//					alert("Entering advanced manipulators, 1st control, start point ");
						}
						return this.DN4.FSM.GS_ADVMENUSHOWN;
						break;
					  case 4:
						iD.draw.advancedManipulatorMenu = {
							x: pts[i].xc2 + 40,
							y: pts[i].yc2,
							w: 10,
							items: [{label: "Remove", act: function() {
								iD.cmdHistory.addAndExec("Remove tangent", 
											[{cmd: "p", el: manip.el,		// undo
											   path: ["points", i],
								  			   more: [{path: ["xc2"], val: pts[i].xc2},
								  			   		  {path: ["yc2"], val: pts[i].yc2}]
								  			  }],
								  			[{cmd: "p", el: manip.el,	// command
											   path: ["points", i],
								  			   more: [{path: ["xc2"], val: pts[i].x2},
								  			   		  {path: ["yc2"], val: pts[i].y2}]
								  			  }]);
								  	 return false;
									 }}
							]
						};
						if(i < pts.length-1) {
		//					alert("Entering advanced manipulators, 2nd control, intermediate point ");
							iD.draw.advancedManipulatorMenu.items[1] =
								  (pts[i].t2 & 1 ?
								    {label: "Unlock tan.", act: function() {
								    	var l = 10;
										iD.cmdHistory.addAndExec("Unlock tangent", 
											[{cmd: "p", el: manip.el,		// undo
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t2"], val: pts[i].t2}]},
											    {path: [i+1],
											     more: [{path: ["t1"], val: pts[i+1].t1}]}]}],
								  			[{cmd: "p", el: manip.el,	// command
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t2"], val: pts[i].t2&6}]},
											    {path: [i+1],
											     more: [{path: ["t1"], val: pts[i+1].t1&6}]}]}]
								  			  );
								    	return false;
								    	}} :
								    {label: "Lock tan.", act: function() {
										iD.cmdHistory.addAndExec("Lock Tangent", 
											[{cmd: "p", el: manip.el,		// undo
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t2"],  val: pts[i].t2}]},
											    {path: [i+1],
											     more: [{path: ["t1"],  val: pts[i+1].t1},
											     		{path: ["xc1"], val: pts[i+1].xc1},
								  			   		    {path: ["yc1"], val: pts[i+1].yc1}]}]}],
								  			[{cmd: "p", el: manip.el,	// command
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t2"], val: pts[i].t2|1}]},
											    {path: [i+1],
											     more: [{path: ["t1"],  val: pts[i+1].t1|1},
											     		{path: ["xc1"], val: pts[i+1].x1 + 
											     							 pts[i].x2 - pts[i].xc2},
								  			   		    {path: ["yc1"], val: pts[i+1].y1 + 
											     							 pts[i].y2 - pts[i].yc2}]}]}]
											  );
										return false;
								    }});
						} else {
		//					alert("Entering advanced manipulators, 2nd control, end point ");
						}
						return this.DN4.FSM.GS_ADVMENUSHOWN;
						break;
					  case 2:
						if(i < pts.length-1) {
		//					alert("Entering advanced manipulators, 2nd veretx, intermediate point ");
							iD.draw.advancedManipulatorMenu = {
								x: pts[i].x2 + 40,
								y: pts[i].y2,
								w: 6,
								items: [ {label: "Curve", act: function() {
									var dxi, dyi, dxi1, dyi1, l, bx, by;
									dxi  = pts[i+1].x2   - pts[i+1].x1;
									dyi  = pts[i+1].y2   - pts[i+1].y1;
									dxi1 = pts[i].x1 - pts[i].x2;
									dyi1 = pts[i].y1 - pts[i].y2;
									if(((dxi != 0) || (dyi != 0)) && ((dxi1 != 0) || (dyi1 != 0))) {
										l = Math.sqrt(dxi*dxi+dyi*dyi);
										dxi /= l; dyi /= l;
										l = Math.sqrt(dxi1*dxi1+dyi1*dyi1);
										dxi1 /= l; dyi1 /= l;
										bx = dxi+dxi1; by = dyi+dyi1;
										l = Math.sqrt(bx*bx+by*by);
										bx /= l; by /= l;
										l = bx * dxi + by * dyi;
										bx *= l; by *= l;			// projection of the half-vector
										dxi  -= bx; dyi  -= by; 
										dxi1 -= bx; dyi1 -= by;
										
										l = 50;		// arbitrary len for new tangent
		
										iD.cmdHistory.addAndExec("Curve", 
											[{cmd: "p", el: manip.el,		// undo
											   path: ["points"], more: [{path:[i],
								  			     more: [{path: ["xc2"], val: pts[i].xc2},
								  			   		    {path: ["yc2"], val: pts[i].yc2}]},
								  			   		    {path:[i+1],
								  			     more: [{path: ["xc1"], val: pts[i+1].xc1},
								  			   		    {path: ["yc1"], val: pts[i+1].yc1}]}]
								  			  }],
								  			[{cmd: "p", el: manip.el,	// command
											   path: ["points"], more: [{path:[i],
								  			     more: [{path: ["xc2"], val: pts[i].x2 - dxi*l},
								  			   		    {path: ["yc2"], val: pts[i].y2 - dyi*l}]},
								  			   		    {path:[i+1],
								  			     more: [{path: ["xc1"], val: pts[i+1].x1 - dxi1*l},
								  			   		    {path: ["yc1"], val: pts[i+1].y1 - dyi1*l}]}]
								  			  }]);
									}
									return false;
								  }},
								  (pts[i].t2 & 4 ?
								    {label: "Unlock pos.", act: function() {
								    	var l = 10;
										iD.cmdHistory.addAndExec("Unlock Position", 
											[{cmd: "p", el: manip.el,		// undo
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t2"], val: pts[i].t2},
											            {path: ["x2"], val: pts[i].x2},
											            {path: ["xc2"], val: pts[i].xc2}]},
											    {path: [i+1],
											     more: [{path: ["t1"], val: pts[i+1].t1},
											            {path: ["x1"], val: pts[i+1].x1},
											            {path: ["xc1"], val: pts[i+1].xc1}]}]}],
								  			[{cmd: "p", el: manip.el,	// command
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t2"], val: pts[i].t2&3},
											            {path: ["x2"], val: pts[i].x2-l},
											            {path: ["xc2"], val: pts[i].xc2-l}]},
											    {path: [i+1],
											     more: [{path: ["t1"], val: pts[i+1].t1&3},
											            {path: ["x1"], val: pts[i+1].x1+l},
											            {path: ["xc1"], val: pts[i+1].xc1+l}]}]}]
								  			  );
								    	return false;
								    	}} :
								    {label: "Lock pos.", act: function() {
								    	var dx = (pts[i].x2 - pts[i+1].x1)/2;
								    	var dy = (pts[i].y2 - pts[i+1].y1)/2;
										iD.cmdHistory.addAndExec("Lock Position", 
											[{cmd: "p", el: manip.el,		// undo
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t2"], val: pts[i].t2},
											            {path: ["x2"], val: pts[i].x2},
											            {path: ["xc2"], val: pts[i].xc2},
											            {path: ["y2"], val: pts[i].y2},
											            {path: ["yc2"], val: pts[i].yc2}]},
											    {path: [i+1],
											     more: [{path: ["t1"], val: pts[i+1].t1},
											            {path: ["x1"], val: pts[i+1].x1},
											            {path: ["xc1"], val: pts[i+1].xc1},
											            {path: ["y1"], val: pts[i+1].y1},
											            {path: ["yc1"], val: pts[i+1].yc1}]}]}],
								  			[{cmd: "p", el: manip.el,	// command
											   path: ["points"], more:
											   [{path: [i],
											     more: [{path: ["t2"], val: pts[i].t2|4},
											            {path: ["x2"], val: pts[i].x2-dx},
											            {path: ["xc2"], val: pts[i].xc2-dx},
											            {path: ["y2"], val: pts[i].y2-dy},
											            {path: ["yc2"], val: pts[i].yc2-dy}]},
											    {path: [i+1],
											     more: [{path: ["t1"], val: pts[i+1].t1|4},
											            {path: ["x1"], val: pts[i+1].x1+dx},
											            {path: ["xc1"], val: pts[i+1].xc1+dx},
											            {path: ["y1"], val: pts[i+1].y1+dy},
											            {path: ["yc1"], val: pts[i+1].yc1+dy}]}]}]
								  			  );
										return false;
										}}),
									{label: "Remove", act: function() {
										iD.cmdHistory.addAndExec("Remove curve point", 
											[{cmd: "p", el: manip.el,	// undo
											   path: ["points"],
								  			   add:  i+1
								  			 },
								  			 {cmd: "p", el: manip.el,		
											   path: ["points"],
											   more:[{
											   	 path: [i+1],
								  			     more: [{path: ["x1"],  val: pts[i+1].x1},
													    {path: ["y1"],  val: pts[i+1].y1},
													    {path: ["xc1"], val: pts[i+1].xc1},
													    {path: ["yc1"], val: pts[i+1].yc1},
													    {path: ["t1"],  val: pts[i+1].t1},
													    {path: ["x2"],  val: pts[i+1].x2},
													    {path: ["y2"],  val: pts[i+1].y2},
													    {path: ["xc2"], val: pts[i+1].xc2},
													    {path: ["yc2"], val: pts[i+1].yc2},
													    {path: ["t2"],  val: pts[i+1].t2}
								  			   		   ]},{
											   	 path: [i],
								  			     more: [{path: ["x2"],  val: pts[i].x2},
													    {path: ["y2"],  val: pts[i].y2},
													    {path: ["xc2"], val: pts[i].xc2},
													    {path: ["yc2"], val: pts[i].yc2},
													    {path: ["t2"],  val: pts[i].t2}
								  			   		   ]}
								  			   		]
								  			  }],
								  			[{cmd: "p", el: manip.el,		// undo
											   path: ["points", i],
								  			   more: [{path: ["x2"],  val: pts[i+1].x2},
								  			   		  {path: ["y2"],  val: pts[i+1].y2},
								  			   		  {path: ["xc2"], val: pts[i+1].xc2},
								  			   		  {path: ["yc2"], val: pts[i+1].yc2},
								  			   		  {path: ["t2"],  val: pts[i+1].t2}]
								  			 },
								  			 {cmd: "p", el: manip.el,	// command
											   path: ["points"],
								  			   rem:  i+1
								  			 }]);
							 		return false;
							 }}, {label: "Add", act: function() {
								 return iD.FSM.GS_ADDINTPOINT;
							 }}
								 ]};
						} else {
		//					alert("Entering advanced manipulators, end point ");
							iD.draw.advancedManipulatorMenu = {
								x: pts[i].x2 + 40,
								y: pts[i].y2,
								w: 6,
								items: [ {label: "Curve", act: function() {
									var dxi, dyi, l;
									dxi = pts[i].x2 - pts[i].x1;
									dyi = pts[i].y2 - pts[i].y1;
									if((dxi != 0) || (dyi != 0)) {
										l = Math.sqrt(dxi*dxi+dyi*dyi);
										dxi /= l; dyi /= l;
										
										l = 50;		// arbitrary len for new tangent
		
										iD.cmdHistory.addAndExec("Curve", 
											[{cmd: "p", el: manip.el,		// undo
											   path: ["points", i], 
								  			     more: [{path: ["xc2"], val: pts[i].xc2},
								  			   		    {path: ["yc2"], val: pts[i].yc2}]
								  			  }],
								  			[{cmd: "p", el: manip.el,	// command
											   path: ["points", i],
								  			     more: [{path: ["xc2"], val: pts[i].x2 - dxi*l},
								  			   		    {path: ["yc2"], val: pts[i].y2 - dyi*l}]
								  			  }]);
									}
								  return false;
								  }}, {label: "Add", act: function() {
										 return iD.FSM.GS_ADDINTPOINT;
								  }}
								 ]};
						}
						return this.DN4.FSM.GS_ADVMENUSHOWN;
						break;
					}
					return this.DN4.FSM.GS_MANIPULATING;
				}
				getManipulatorTooltip(el, manip) {
					var out = "";
					var v = manip % 7;
					switch(v) {
					  case 1:
					  case 2:
						out = "Drag: Move edge point. RMB: Open Advanced Menu";
						break;
					  case 3:
					  case 4:
						out = "Drag: Shape edge tangent. RMB: Open Advanced Menu";
						break;
					  default:
						out = "Error!";
						break;
					}
					return out;
				}
			}			
			this.manipulators = new Edge_Manipulator(tool);	
		}
		// draw the element (Edge)
		draw(context, s, d) {	// s -> element  properties
												// d -> metatype properties
			var points = s.points;
			var i, j;
			context.save();
	
	//		context.strokeStyle = d.col;	//  sets the color
	
			// changes the style if the object is selected
			var linStyle;
			if(s.selected) {
				if(s.hovering) {
					if(typeof d["lHovSel"] === 'undefined') {linStyle = [{scol: "#ff0000", swidth: 3}];}
													   else {linStyle = d.lHovSel;}
				} else {
					if(typeof d["lSel"] === 'undefined') {linStyle = [{scol: "#000000", swidth: 3}];}
													   else {linStyle = d.lSel;}
				}
			} else {
				if(s.hovering) {
					if(typeof d["lHov"] === 'undefined') {linStyle = [{scol: "#ff0000", swidth: 1}];}
													   else {linStyle = d.lHov;}
				} else {
					if(typeof d["lNorm"] === 'undefined') {linStyle = [{scol: "#000000", swidth: 1}];}
													   else {linStyle = d.lNorm;}
				}
			}
			
			// draws the bezier curve
	//if(s.to == -1) alert(JSON.stringify(points));
			for(j = 0; j < linStyle.length; j++) {
				ExtraGraph.setStrokeDrawingProps(context, s, linStyle[j]);
			  	for(i = 0; i < points.length; i++) {
				  	context.beginPath();
				  	context.moveTo(points[i].x1, points[i].y1);
				  	context.bezierCurveTo(points[i].xc1, points[i].yc1,
				  						  points[i].xc2, points[i].yc2,
				  						  points[i].x2, points[i].y2);
				  	context.stroke();
			  	}
			}
			
		  	i = points.length-1;
		  	if(i >= 0) {
			  	// draws the arrow at the beginning.
			  	if((points[0].x1 != points[0].xc1) && (points[0].y1 != points[0].yc1))	// for curves
			  		ExtraGraph.drawArrow(context, points[0].xc1, points[0].yc1,
			  							 points[0].x1,  points[0].y1, s, d.sArr);
			  	else																	// for straight lines
			  		ExtraGraph.drawArrow(context, points[0].xc2, points[0].yc2,
			  							 points[0].x1,  points[0].y1, s, d.sArr);	  	
			  	// draws the arrow at the end.
			  	if((points[i].x2 != points[i].xc2) && (points[i].y2 != points[i].yc2))	// for curves
			  		ExtraGraph.drawArrow(context, points[i].xc2, points[i].yc2,
			  							 points[i].x2,  points[i].y2, s, d.eArr);
			  	else																	// for straight lines
			  		ExtraGraph.drawArrow(context, points[i].xc1, points[i].yc1,
			  							 points[i].x2,  points[i].y2, s, d.eArr);
		  	}
	
			// draw broken arcs
		  	for(i = 0; i < points.length; i++) {
			  	if(!(points[i].t1 & 4)) {	
				  	if((points[i].x1 != points[i].xc1) && (points[i].y1 != points[i].yc1))	// for curves
				  		ExtraGraph.drawArrow(context, points[i].xc1, points[i].yc1,
				  							 points[i].x1,  points[i].y1, s, d.basArr);
				  	else											// for straight lines
				  		ExtraGraph.drawArrow(context, points[i].xc2, points[i].yc2,
				  		                     points[i].x1, points[i].y1, s, d.basArr);
			  	}
			  	if(!(points[i].t2 & 4)) {	
				  	if((points[i].x2 != points[i].xc2) && (points[i].y2 != points[i].yc2))	// for curves
				  		ExtraGraph.drawArrow(context, points[i].xc2, points[i].yc2,
				  							 points[i].x2,  points[i].y2, s, d.baeArr);
				  	else											// for straight lines
				  		ExtraGraph.drawArrow(context, points[i].xc1, points[i].yc1,
				  		                     points[i].x2, points[i].y2, s, d.baeArr);
			  	}
		  	}
	
		  	context.restore();
		};
	
		// check if a point belongs to the element (Edge)
		isOver(s, d, x, y) {	// s -> element  properties
												// d -> metatype properties
			var points = s.points;
			var i, dist;
			
			// compute the distance from the first segment of the spline
			var minDist = jsBezier.distanceFromCurve(
							{x: x, y: y},
							[{x: points[0].x1,  y: points[0].y1},
							 {x: points[0].xc1, y: points[0].yc1},
							 {x: points[0].xc2, y: points[0].yc2},
							 {x: points[0].x2,  y: points[0].y2}]
						  ).distance;
						  
			// check the distance from the other segments
		  	for(i = 1; i < points.length; i++) {
				dist = jsBezier.distanceFromCurve(
							{x: x, y: y},
							[{x: points[i].x1,  y: points[i].y1},
							 {x: points[i].xc1, y: points[i].yc1},
							 {x: points[i].xc2, y: points[i].yc2},
							 {x: points[i].x2,  y: points[i].y2}]
						  ).distance;
				if(dist < minDist) {
					minDist = dist;
				}
		  	}
	//this.DN4.draw.context.clearRect(0,0,100,30);
	//ExtraGraph.centerText(50, 32, (Math.round(minDist*100)/100) + " " + (3 / this.DN4.draw.zoom), "black", 16);
			
			// returns true if the distance is less than a zoom-dependent threshold
			return (minDist < 3 / this.DN4.draw.zoom);
		};
		// checks if the element intersects a box (Edge)
		selBox(s, d, x, y, w, h) {
			var points = s.points;
			var i;
	
		  	for(i = 0; i < points.length; i++) {
				if(!((points[i].x1 >= x) && (points[i].y1 >= y) &&
				     (points[i].x1 <= x + w) && (points[i].y1 <= y + h))) {
					return false;
				}
				if(!((points[i].xc1 >= x) && (points[i].yc1 >= y) &&
					 (points[i].xc1 <= x + w) && (points[i].yc1 <= y + h))) {
					return false;
				}
				if(!((points[i].xc2 >= x) && (points[i].yc2 >= y) &&
					 (points[i].xc2 <= x + w) && (points[i].yc2 <= y + h))) {
					return false;
				}
				if(!((points[i].x2 >= x) && (points[i].y2 >= y) &&
					 (points[i].x2 <= x + w) && (points[i].y2 <= y + h))) {
					return false;
				}
			}
			return true;
		}
		// draw the manipulators for the element (Edge)
		drawManipulators(context, el) {	// el -> element
			var s = el.s;						// gets the element properties
			var points = s.points;
			var i;
			context.save();
			context.strokeStyle = "#0077ff";	//  sets the colors
			context.fillStyle   = "#ffffff";
	
			// draws the manipulators for the bezier curve
		  	for(i = 0; i < points.length; i++) {
			  	context.beginPath();
			  	context.moveTo(points[i].x1,  points[i].y1);
			  	context.lineTo(points[i].xc1, points[i].yc1);
			  	context.moveTo(points[i].x2,  points[i].y2);
			  	context.lineTo(points[i].xc2, points[i].yc2);
			  	if(i < points.length - 1) {
			  		var nx, ny;
			  		var ta1, ta2;
			  		var dx1 = points[i].xc1 - points[i].x1;
			  		var dy1 = points[i].yc1 - points[i].y1;
			  		var dx2 = points[i].xc2 - points[i].x2;
			  		var dy2 = points[i].yc2 - points[i].y2;
	/*		  		if((dx1 == 0) && (dy1 == 0)) {	// first tangent is zero
				  		if((dx2 == 0) && (dy2 == 0)) {	// also the second tangent is zero
			  		}
				  	context.moveTo(points[i].x2, points[i].y2 + nx);
				  	context.lineTo(points[i].x2, points[i].y2 + ny);
	*/		  	}
			  	context.stroke();
	//context.fillStyle   = "#ffffff";
				context.fillRect(points[i].x1-2,  points[i].y1-2,  5,5);
				context.fillRect(points[i].xc1-2, points[i].yc1-2, 5,5);
	//context.fillStyle   = "#ff0055";
				context.fillRect(points[i].xc2-2, points[i].yc2-2, 5,5);
				context.fillRect(points[i].x2-2,  points[i].y2-2,  5,5);
				context.strokeRect(points[i].x1-2,  points[i].y1-2,  5,5);
				context.strokeRect(points[i].x2-2,  points[i].y2-2,  5,5);
				context.strokeRect(points[i].xc1-2, points[i].yc1-2, 5,5);
				context.strokeRect(points[i].xc2-2, points[i].yc2-2, 5,5);
				this.DN4.draw.addManipulator(points[i].x1,  points[i].y1, 3, i*7+1, el, 
											 this.manipulators);
				this.DN4.draw.addManipulator(points[i].x2,  points[i].y2, 3, i*7+2, el, 
											 this.manipulators);
				this.DN4.draw.addManipulator(points[i].xc1,  points[i].yc1, 3, i*7+3, el, 
											 this.manipulators);
				this.DN4.draw.addManipulator(points[i].xc2,  points[i].yc2, 3, i*7+4, el, 
											 this.manipulators);
		  	}
		  	// highlights the hovering
		  	if(this.DN4.draw.hoveringManipEl === el) {	// only for the current element
			  	for(i = 0; i < points.length; i++) {
					context.fillStyle   = "#ff0000";
			  		if(this.DN4.draw.hoveringManipNum == i*7+1) {
						context.fillRect(points[i].x1-2,  points[i].y1-2,  5,5);
			  		}
			  		if(this.DN4.draw.hoveringManipNum == i*7+3) {
						context.fillRect(points[i].xc1-2, points[i].yc1-2, 5,5);
			  		}
			  		if(this.DN4.draw.hoveringManipNum == i*7+4) {
						context.fillRect(points[i].xc2-2, points[i].yc2-2, 5,5);
			  		}
			  		if(this.DN4.draw.hoveringManipNum == i*7+2) {
						context.fillRect(points[i].x2-2,  points[i].y2-2,  5,5);
			  		}
			  	}
		  	}
			context.restore();	  	
		}
		// recompute bounding box (Edge)
		getBbox(s, d) {
			var i;
			var points = s.points;
			var bbox = {x:points[0].x1, y:points[0].y1, w:points[0].x1, h:points[0].y1};
			for(i = 0; i < points.length; i++) {
				ExtraGraph.extendBbox(points[i].x1, points[i].y1, bbox);
				ExtraGraph.extendBbox(points[i].xc1, points[i].yc1, bbox);
				ExtraGraph.extendBbox(points[i].xc2, points[i].yc2, bbox);
				ExtraGraph.extendBbox(points[i].x2, points[i].y2, bbox);
			}
			bbox.w -= bbox.x;
			bbox.h -= bbox.y;
			return bbox;
		}
		// apply the transofrmations to the element
		applyManip(transf, el) {
			var s = el.s;						// gets the element properties
			var points = s.points;
			var i, tp1, tp2, tpc1, tpc2;
			var out = {cmd: "p", el: el, path: ["points"], more: []};
	
		  	for(i = 0; i < points.length; i++) {
				tp1 = ExtraGraph.transformPoint(points[i].x1,  points[i].y1,  this.DN4.draw.groupManType, transf);
				tpc1 = ExtraGraph.transformPoint(points[i].xc1, points[i].yc1, this.DN4.draw.groupManType, transf);
				tpc2 = ExtraGraph.transformPoint(points[i].xc2, points[i].yc2, this.DN4.draw.groupManType, transf);
				tp2 = ExtraGraph.transformPoint(points[i].x2,  points[i].y2,  this.DN4.draw.groupManType, transf);
				out.more[i] = {path: [i], more:[
					{path: ["x1"],  val: tp1.x},
					{path: ["y1"],  val: tp1.y},
					{path: ["xc1"], val: tpc1.x},
					{path: ["yc1"], val: tpc1.y},
					{path: ["x2"],  val: tp2.x},
					{path: ["y2"],  val: tp2.y},
					{path: ["xc2"], val: tpc2.x},
					{path: ["yc2"], val: tpc2.y}
				]};
			}
	
			return [out];		
		}
		
		// creates a global undo for the element
		makeUndoObj(el) {
			var k;
			var pts = el.s.points;
	
			var out = {cmd: "p", el: el, path: ["points"], more: []};
			for(k = 0; k < pts.length; k++) {
				out.more[k] = {path: [k], more:[
					{path: ["x1"],  val: pts[k].x1},
					{path: ["y1"],  val: pts[k].y1},
					{path: ["xc1"], val: pts[k].xc1},
					{path: ["yc1"], val: pts[k].yc1},
					{path: ["t1"],  val: pts[k].t1},
					{path: ["x2"],  val: pts[k].x2},
					{path: ["y2"],  val: pts[k].y2},
					{path: ["xc2"], val: pts[k].xc2},
					{path: ["yc2"], val: pts[k].yc2},
					{path: ["t2"],  val: pts[k].t2}
				]};
			}
			return out;
		}
	
		// adds intermediate point (only for edgest)
		addIntermediatePoint(el, s, d, x, y) {
													// el -> element
													// e  -> element  properties
													// d  -> metatype properties
			var points = s.points;
			var i, dist, fi, loc;
			
			// compute the distance from the first segment of the spline
			var D = jsBezier.distanceFromCurve(
							{x: x, y: y},
							[{x: points[0].x1,  y: points[0].y1},
							 {x: points[0].xc1, y: points[0].yc1},
							 {x: points[0].xc2, y: points[0].yc2},
							 {x: points[0].x2,  y: points[0].y2}]
						  );
			var minDist = D.distance;
			loc = D.location;
			fi = 0;			  
			// check the distance from the other segments
		  	for(i = 1; i < points.length; i++) {
		  		D = jsBezier.distanceFromCurve(
							{x: x, y: y},
							[{x: points[i].x1,  y: points[i].y1},
							 {x: points[i].xc1, y: points[i].yc1},
							 {x: points[i].xc2, y: points[i].yc2},
							 {x: points[i].x2,  y: points[i].y2}]
						  );
				dist = D.distance;
				if(dist < minDist) {
					minDist = dist;
					fi = i;
					loc = D.location;
				}
		  	}
		  	
		  	// finds the new end points, and control points of the cutted curves.
		  	var Ix, Iy, Ipxc2, Ipyc2, Ipxc1, Ipyc1, Inxc1, Inyc1, Inxc2, Inyc2, Poc;
		  	Poc = jsBezier.pointOnCurve(
							[{x: points[fi].x1,  y: points[fi].y1},
							 {x: points[fi].xc1, y: points[fi].yc1},
							 {x: points[fi].xc2, y: points[fi].yc2},
							 {x: points[fi].x2,  y: points[fi].y2}], 1-loc	// cannot understand
							 												// 1-, but it is necessary:
							 												// a bug in <jsBezier.js>?
						  );
			Ix = Poc.x;
			Iy = Poc.y;
		  	Poc = jsBezier.pointOnCurve(
							[{x: points[fi].x1,  y: points[fi].y1},
							 {x: points[fi].xc1, y: points[fi].yc1},
							 {x: points[fi].xc2, y: points[fi].yc2}], 1-loc
						  );
			Ipxc2 = Poc.x;
			Ipyc2 = Poc.y;
		  	Poc = jsBezier.pointOnCurve(
							[{x: points[fi].x1,  y: points[fi].y1},
							 {x: points[fi].xc1, y: points[fi].yc1}], 1-loc
						  );
			Ipxc1 = Poc.x;
			Ipyc1 = Poc.y;
		  	Poc = jsBezier.pointOnCurve(
							[{x: points[fi].xc1, y: points[fi].yc1},
							 {x: points[fi].xc2, y: points[fi].yc2},
							 {x: points[fi].x2,  y: points[fi].y2}], 1-loc
						  );
			Inxc1 = Poc.x;
			Inyc1 = Poc.y;
		  	Poc = jsBezier.pointOnCurve(
							[{x: points[fi].xc2, y: points[fi].yc2},
							 {x: points[fi].x2,  y: points[fi].y2}], 1-loc
						  );
			Inxc2 = Poc.x;
			Inyc2 = Poc.y;
	
	//alert("Add. Int. Point. at " + x + ", " + y + " found at curve " + fi + ", t = " + loc +"\n"+
	//      "p1: (" + points[fi].x1  + ", " + points[fi].y1  + ") -- (" +
	//                Ipxc1          + ", " + Ipyc1          + + ") -- (" +
	//                Ipxc2          + ", " + Ipyc2          + ") -- (" +
	//                Ix             + ", " + Iy             + ")\n" +
	//      "p2: (" + Ix             + ", " + Iy             + ") -- (" +
	//                Inxc1          + ", " + Inyc1          + ") -- (" +
	//                Inxc2          + ", " + Inyc2          + ") -- (" +
	//                points[fi].x2  + ", " + points[fi].y2  + ")");
	
			this.DN4.cmdHistory.addAndExec("Add point to curve",
			  	 [{cmd: "p", el: el,		// undo
				   path: ["points", fi],
	  			   more: [{path: ["x2"],  val: points[fi].x2},
	  			   		  {path: ["y2"],  val: points[fi].y2},
	  			   		  {path: ["xc2"], val: points[fi].xc2},
	  			   		  {path: ["yc2"], val: points[fi].yc2},
	  			   		  {path: ["xc1"], val: points[fi].xc1},
	  			   		  {path: ["yc1"], val: points[fi].yc1},
	  			   		  {path: ["t2"],  val: points[fi].t2}]
	  			 },
	  			 {cmd: "p", el: el,	
				   path: ["points"],
	  			   rem:  fi+1
	  			 }],
				[{cmd: "p", el: el,	// command
				   path: ["points"],
	  			   add:  fi+1
	  			 },
	  			 {cmd: "p", el: el,		
				   path: ["points"],
				   more:[{
				   	 path: [fi+1],
	  			     more: [{path: ["x1"],  val: Ix},
						    {path: ["y1"],  val: Iy},
						    {path: ["xc1"], val: Inxc1},
						    {path: ["yc1"], val: Inyc1},
						    {path: ["t1"],  val: 7},
						    {path: ["xc2"], val: Inxc2},
						    {path: ["yc2"], val: Inyc2},
						    {path: ["x2"],  val: points[fi].x2},
						    {path: ["y2"],  val: points[fi].y2},
						    {path: ["t2"],  val: points[fi].t2}
	  			   		   ]},{
				   	 path: [fi],
	  			     more: [{path: ["x2"],  val: Ix},
						    {path: ["y2"],  val: Iy},
						    {path: ["xc2"], val: Ipxc2},
						    {path: ["yc2"], val: Ipyc2},
						    {path: ["xc1"], val: Ipxc1},
						    {path: ["yc1"], val: Ipyc1},
						    {path: ["t2"],  val: 7}
	  			   		   ]}
	  			   		]
	  			  }]);
			}
		}
		// the edge meta type
		this.e = new Edge_MetaTypeElement("e", tool);
	}
}